import java.net.*;
import java.io.*;
import java.util.*;

public class ControlSocket extends Thread {
	ServerSocket socket;
	Socket clientSocket = null;
	UDPServer parent = null;
	int port;
	String s;

	public ControlSocket(UDPServer udps, int portNo) {
		port = portNo;
		parent = udps;
	}

	public void run() {
		try {
			socket = new ServerSocket(port);
			
			while (true) {
				ProcessPacket();
			}
		} catch (IOException e) {
			System.out.println("ControlSocket open socket "+e);
			System.exit(-1);
		}
	}

	public void ProcessPacket() {

		try {
			clientSocket = socket.accept();
		} catch (IOException e) {
			System.out.println("ControlSocket accept socket "+e);
			System.exit(-1);
		}

		new ControlHandler(parent, clientSocket).start();
	}
}
