import java.io.*; 
import java.net.*; 
import java.util.*; 

public class Node {

  private CommThread pctd_comm_thread;
  private long updatetime;
  private long bytes=0;
  private Integer critical;

  public Node (int papplication, char pmode, char pstatus,
               int pserverport, InetAddress pcorrespondent, 
               long pbytes, long ptime) { 

    critical =  new Integer(1);
    pctd_comm_thread = new CommThread(papplication, pmode, pstatus, pserverport, 
				      pcorrespondent, pbytes, ptime, this);

    pctd_comm_thread.start();
  }

  public void UpdateData(long pbytes, long ptime) {
    synchronized(critical) {
      updatetime = ptime;
      bytes = pbytes;
    }
  }

  public long GetBytes() {
    synchronized(critical) {
      return bytes;
    }
  }

  public long GetTime() {
    synchronized(critical) {
      return updatetime;
    }
  }

  public void EndConn(long pbytes, long ptime) {
    UpdateData(pbytes, ptime);
    pctd_comm_thread.Terminate();
  }

}; 
