import java.net.*;
import java.io.*;
import java.util.*;

public class UDPServer extends Thread {
        private Voice parent;

	DatagramSocket socket;
	DatagramPacket packet;
	int port = 0;
	byte[] buffer = new byte[Constants.UDPbuffer];
	String s;
	InetAddress group;
	UDPHandler handler;
	Hashtable voiceHandle;
	ControlSocket servSock;


	/*

	  This code looks broken.  removed 2/6/99 -dam 

	public static void main(String[] argv) {
		UDPServer udp = new UDPServer(11111, null);
		udp.start();
	}
	*/

	public UDPServer(int portnum, Voice myparent) {
		voiceHandle = new Hashtable();
		packet = new DatagramPacket(buffer, buffer.length);
		port = portnum;

		// Open up new socket for control purposes
		// Open at UDPSocket number + 1
                parent = myparent;
		servSock = new ControlSocket(this,portnum+1);
		servSock.start(); 
		
		try {
			socket = new DatagramSocket(port);
		} catch (IOException e) {		
			System.out.println("UDP Server create: "+e);
			System.exit(-1);
		}
	}

	public void run() {
		while (true) {
			ProcessPacket();
		}
	}

	public void ProcessPacket() {

		try {
			socket.receive(packet);
		} catch (IOException e) {
			System.out.println("got an error "+e);
		}

		//Search whether the file for this connection exist
		//If exist -> just process the packet with existing handler
		//If doesn't exist -> create new handler

		handler = (UDPHandler) voiceHandle.get(""+
			packet.getAddress().getHostName()+packet.getPort());

		if (handler != null) { 
			// Handler already exist
			handler.Process(packet);
		} else { 
			// New voice stream
			handler = new UDPHandler(packet, parent);
			voiceHandle.put(""+packet.getAddress().getHostName()+
					packet.getPort(), handler);

			// place simplex voice call to answer the caller
			parent.GenerateAnswerCall(packet.getAddress().getHostAddress());

		}
	}
}
